/*
	Almight.js
	almight.config.js

	Copyright 2012 EISYS, Inc.
*/


/**
 * Almight基本設定
 */

var almight = {
	/**
	* **【必須】ゲーム固有のIDを設定します**
	*
	* @property id 
	* @type String
	* @required
	*/
	id: 'kasumi',


	/**
	* **ゲームタイトル**
	*
	* ゲームのタイトルを設定します
	* ウィンドウのタイトルバーには、この文字列が表示されます
	*
	* @property title 
	* @type String
	* @default 'Almight AVG Engine'
	*/
	title: 'かすみちゃん物語～俺のセフレは○学生～【体験版】',


	/**
	* **ゲーム画面横幅**
	*
	* ゲームの画面の横幅をpxで指定します
	*
	* @property width 
	* @type Number
	* @default 800
	*/
	width: 1229,


	/**
	* **ゲーム画面縦幅**
	*
	* ゲームの画面の縦幅をpxで指定します
	*
	* @property width 
	* @type Number
	* @default 800
	*/
	height: 768,


	/**
	* **デバッグモードにするか**
	*
	* 0: デバッグモードにしない（致命的なエラーが発生した場合は処理が停止します）
	* 1: デバッグモードにする（シナリオ実行ログ・実行エラーが表示されます）
	* 2: 拡張デバッグモードにする（より詳細に表示されます）
	*
	* @property debug 
	* @type Number
	* @default 0
	*/
	debug: 0,


	/**
	* **プラグインのファイルパス**
	*
	* プラグインのファイルパスを index.htmlからの相対パスで設定します
	*
	* @property pluginPath 
	* @type Array
	* @default []
	*/
	pluginPath: [],


	/**
	* **セーブスロットの数**
	*
	* スマートフォン環境では半分になります
	*
	* @property slotCount 
	* @type Number
	* @default 20
	*/
	slotCount: 20,


	/**
	* **最初に読み込むシナリオファイル名**
	*
	* @property first 
	* @type String
	* @default 'first.ks'
	*/
	first: 'first.ks',


	/**
	* **ゲームアセットフォルダを指定します**
	*
	* lib/index.html からの相対パスで、ゲームのアセットフォルダを指定します。
	* 通常変更する必要はありません
	*
	* @property gamePath 
	* @type String
	* @default '../game'
	*/
	gamePath: '../game',



	/**
	* **効果音のバッファ数**
	*
	* ここで指定した数だけ効果音を同時に鳴らすことができます。
	* 大きな値を指定するとパフォーマンスが低下するので、必要な数だけ指定します
	*
	* @property seCounts 
	* @type Number
	* @default 3
	*/
	seCounts: 3,


	/**
	* **前景レイヤー数**
	*
	* ここで指定した数だけ前景レイヤーを使用できます。
	* 大きな値を指定するとパフォーマンスが低下するので、必要な数だけ指定します
	*
	* @property layerCounts 
	* @type Number
	* @default 6
	*/
	layerCounts: 6,


	/**
	* **メッセージレイヤー数**
	*
	* ここで指定した数だけメッセージレイヤーを使用できます。
	* 大きな値を指定するとパフォーマンスが低下するので、必要な数だけ指定します
	*
	* @property layerCounts 
	* @type Number
	* @default 2
	*/
	messageCounts: 2,


	/**
	* **初期状態でメッセージレイヤー0を表示するか**
	*
	* 通常全てのメッセージレイヤーは初期状態では非表示ですが、ここでtrueを指定すると
	* メッセージレイヤー0を初期状態で表示状態にします。
	*
	* @property initMessageVisible 
	* @type Boolean
	* @default true
	*/
	initMessageVisible: true,


	/**
	* **メッセージ枠の画像**
	*
	* メッセージレイヤーに表示する枠の画像ファイルを指定します。
	* これが指定されていると、frameColorやframeOpacityは無視されます。
	*
	* @property frameGraphic 
	* @type String
	*/
	frameGraphic: '',


	/**
	* **メッセージ枠の色**
	*
	* メッセージレイヤーに表示する枠の色を指定します。16進数で指定します（#000000）
	*
	* @property frameColor 
	* @type String
	*/
	frameColor: '#000000',


	/**
	* **メッセージ枠の不透明度**
	*
	* メッセージレイヤーに表示する枠の不透明度を指定します。0?255で指定します。
	*
	* @property frameOpacity 
	* @type Number
	*/
	frameOpacity: 100,


	/**
	* **メッセージ枠の余白**
	*
	* メッセージレイヤーの余白をpx単位で指定します。
	* 画像ファイルをメッセージレイヤーに指定した場合は、文字を表示する位置をこの余白で調整します。
	*
	* @property messageMarginLeft
	* @property messageMarginTop
	* @property messageMarginRight
	* @property messageMarginBottom
	* @type Number
	*/
	messageMarginLeft: 22,
	messageMarginTop: 18,
	messageMarginRight: 20,
	messageMarginBottom: 20,


	/**
	* **メッセージレイヤーの初期位置**
	*
	* メッセージレイヤーの初期位置とサイズをpx単位で指定します。
	* すべてpositionタグのLeft, Top, Width, Heightに対応します。
	*
	* @property messageLeft
	* @property messageTop\
	* @property messageWidth
	* @property messageHeight
	* @type Number
	*/
	messageLeft: 30,
	messageTop: 30,
	messageWidth: 900,
	messageHeight: 300,


	/**
	* **フォントサイズ**
	*
	* デフォルトのフォントサイズをpx単位で指定します。
	*
	* @property messageFontSize
	* @type Number
	*/
	messageFontSize: 24,


	/**
	* **行間**
	*
	* デフォルトの行間をpx単位で指定します。
	*
	* @property messageLineHeight
	* @type Number
	*/
	messageLineHeight: 6,


	/**
	* **文字色**
	*
	* デフォルトの文字色を指定します。RGBを16進数で指定します（#000000）
	* また、rgba(0,0,0,0.5)などのRGBA指定も可能です
	*
	* @property messageColor
	* @type String
	*/
	messageColor: '#ffffff',


	/**
	* **文字ボールド**
	*
	* 文字をボールド（太字）で表示するかどうか指定します。
	*
	* @property messageBold
	* @type Boolean
	*/
	messageBold: false,


	/**
	* **文字につける影の色**
	*
	* 文字につける影の色をRGBを16進数で指定します（#000000）
	* また、rgba(0,0,0,0.5)などのRGBA指定も可能です
	*
	* @property messageShadowColor
	* @type String
	*/
	messageShadowColor: 'rgba(0,0,0,0.5)',


	/**
	* **影の描画**
	*
	* 文字に影を描画するかどうか指定します。
	*
	* @property messageShadow
	* @type Boolean
	*/
	messageShadow: true,



	/**
	* **シーン回想モードを利用するか**
	*
	* シーン回想モードを使うかどうか指定します。
	*
	* @property sceneWindow
	* @type Boolean
	*/
	sceneWindow: true,


	/**
	* **CG閲覧モードを利用するか**
	*
	* CG閲覧モードを使うかどうか指定します。
	*
	* @property cgmodeWindow
	* @type Boolean
	*/
	cgmodeWindow: true,



	/**
	* **「タイトルに戻る」で戻るシナリオファイル名**
	*
	* 「タイトルに戻る」で戻るシナリオファイル名を指定します。
	*
	* @property backTitleStorage
	* @type String
	* @default 'first.ks'
	*/
	backTitleStorage: 'first.ks',


	/**
	* **「タイトルに戻る」で戻るラベル名**
	*
	* 「タイトルに戻る」で戻るシナリオファイル名を指定します。
	*
	* @property backTitleTarget
	* @type String
	* @default '*start'
	*/
	backTitleTarget: '*title',


	/**
	* **ファイルパスデータを利用するか**
	*
	* @property filePath 
	* @type Boolean
	* @default false
	*/
	filePath: true
};


	/**
	* **imageタグのpos属性の位置を設定する**
	*
	* @property imagePos 
	* @type Object
	*/
	almight.imagePos = {
		left: almight.width * (1/4) - 50,
		l: almight.width * (1/4) - 50,

		left_center: almight.width * (1/3) - 50,
		lc: almight.width * (1/3) - 50,

		center: almight.width * (2/4),
		c: almight.width * (2/4),

		right_center: almight.width * (2/3) + 50,
		rc: almight.width * (2/3) + 50,

		right: almight.width * (3/4) + 50,
		r: almight.width * (3/4) + 50
	};



/**
 * 独自に関数を設定する場合はここに記述出来ます
 */





/**
 * Almightを初期化して実行開始
 */
$(function() {
	window.onerror = function(){
		if(typeof Titanium === 'object') {
			$('#almight-loading span').html('エラーが発生しました<br><a href="javascript:Titanium.App.fireEvent(\'setExit\');">終了する</a>');
		} else {
			$('#almight-loading span').html('エラーが発生しました');
		}
	};
	var loadCount = 0;
	
	var path = [];

	// Androidならiscrollを読み込む
	if(/(android)/i.test(navigator.userAgent)) {
		path.push('js/iscroll-lite.js');
	}

	path.concat(almight.pluginPath);

	if(path.length !== 0) {
		$.each(path, function(index) {
			var name = this;
			$.ajax({
				type: 'GET',
				url: name,
				cache: false,
				dataType: 'script',
				success: function(msg){
					loadCount++;
					// 全てロード完了
					if(loadCount === path.length) {
						init();
					}
				},
				error: function(msg){
					$.error('JavaScriptの読み込みに失敗しました : ' + name);
				}
			});
		});
	} else {
		init();
	}

	function init() {
		var first = almight.first;
		// Almightを初期化
		almight = new Almight(almight);

		window.onerror = function(){};
		$(window).trigger('resize');

		// シナリオをロードして実行開始
		almight.script.load(first, function() {
			almight.script.dequeue();
			$('#almight').fadeIn('normal', function(){
				$('#almight-loading').remove();
			});
		});
	}
});
